#include "ISommePtr.h"
#include "../../Commun/Commun/Somme_h.h"
#include "../../Commun/Commun/UUID_Fabriques.h"
#include <memory>
#include <string>
using namespace std;

ISommePtr::ISommePtr(const wstring &adresse) {
   const int NBITF_VOULUES = 1, ITF_ISOMME = 0;
   MULTI_QI Interfaces[NBITF_VOULUES] = {
      { &IID_ISomme,  0, S_OK }
   };
   COSERVERINFO ServeurVoulu = {
      0,  const_cast<wchar_t*>(adresse.c_str()), 0, 0
   };
   HRESULT hr = CoCreateInstanceEx(
      CLSID_FabriqueSommeExterne, // fabrique voulue
      0, // != 0 seulement pour un agrgat
      CLSCTX_LOCAL_SERVER, // contexte prfr de serveur
      &ServeurVoulu, // le COSERVERINFO
      NBITF_VOULUES, // nb. Elments du tableau ItfDemandees
      Interfaces
   ); // MULTI_QI[]
   if (FAILED(hr) || FAILED(Interfaces[ITF_ISOMME].hr))
      throw erreur_creation{};
   p.reset(static_cast<ISomme*>(Interfaces[ITF_ISOMME].pItf));
}

ISommePtr::~ISommePtr() = default;

int ISommePtr::somme(int x, int y) const {
   int resultat;
   if (auto hr = p->somme(x, y, &resultat); FAILED(hr))
      throw erreur_calcul{};
   return resultat;
}
