#ifndef GESTIONNAIRE_DE_VERROU_H
#define GESTIONNAIRE_DE_VERROU_H

#include <atomic>
#include <mutex>
#include <condition_variable>

class GestionnaireDeVerrou {
   static GestionnaireDeVerrou singleton;
   GestionnaireDeVerrou();
   std::atomic<unsigned long> cptobj;
   mutable std::mutex m;
   mutable std::condition_variable fin;
public:
   static GestionnaireDeVerrou &get() {
      return singleton;
   }
   void incrementer();
   void decrementer();
   bool est_vide() const;
   void attendre_fin() const {
      std::unique_lock<std::mutex> verrou{ m };
      fin.wait(verrou);
   }
};

#endif
