#define _WIN32_DCOM
// Fichier: ServeurSomme.cpp

#include "IClassFactoryImpl.h"
#include "Sommateur.h"
#include "Registry.h" // RegisterServer(), UnregisterServer()
#include "ConversionChaines.h"
#include "ChargeurCOM.h"
#include "GestionnaireDeVerrou.h"
#include "../../Commun/Commun/UUID_Fabriques.h" // UUID de FabriqueSomme
#include <string>
#include <iostream>
using namespace std;

void lancer_contexte();
void fermer_contexte();

int main(int argc, char *argv[]) {
   if (argc == 2) {
      static const string
         PREFIXE_WIN = "/", PREFIXE_UNIX = "-",
         PARAM = majuscules(argv[1]),
         ENREGISTRER = majuscules("RegServer"),
         DESENREGISTRER = majuscules("UnregServer"),
         LANCEMENTCOM= majuscules("Embedding");
      if (PARAM == PREFIXE_WIN  + ENREGISTRER ||
          PARAM == PREFIXE_UNIX + ENREGISTRER) {
         HRESULT hr = RegisterServer(
            StringToWString(argv[0]), CLSID_FabriqueSommeExterne,
            L"Composant externe dmonstrateur",
            L"Composant.Somme.Externe",
            L"Composant.Somme.Externe.1"
         );
         if (SUCCEEDED(hr))
            cout << "Inscription russie de " << argv[0] << endl;
         else
            cerr << "chec  l'inscription de " << argv[0]<< " code " << hr << '\n';
         return hr;
      } else if (PARAM == PREFIXE_WIN  + DESENREGISTRER ||
                 PARAM == PREFIXE_UNIX + DESENREGISTRER) {
         HRESULT hr = UnregisterServer(
            CLSID_FabriqueSommeExterne, L"Composant.Somme.Externe", L"Composant.Somme.Externe.1"
         );
         if (SUCCEEDED(hr))
            cout << "Desinscription reussie de " << argv[0]<< endl;
         else
            cerr << "Echec a la desinscription de " << argv[0]<< " code " << hr << '\n';
         return hr;
      }
      else if (PARAM == PREFIXE_WIN + LANCEMENTCOM ||
               PARAM == PREFIXE_UNIX + LANCEMENTCOM) {
         ChargeurCOM cc{ ChargeurCOM::MultiThreaded{} };
         lancer_contexte();
         GestionnaireDeVerrou::get().attendre_fin();
         fermer_contexte();
      } else
         cerr << "Parametre invalide: " << PARAM << '\n';
   } else
      cerr << "Nombre de parametres invalide: " << argc << '\n';
}


namespace { // localiser les globales
   DWORD Jeton = {};
   IClassFactory *pFab = {};
}
void lancer_contexte () {
   ::pFab = new IClassFactoryImpl<Sommateur>;
   CoRegisterClassObject(
      CLSID_FabriqueSommeExterne, ::pFab,
       CLSCTX_SERVER, REGCLS_MULTIPLEUSE |
                      REGCLS_SUSPENDED, &::Jeton);
   CoResumeClassObjects();
}
void fermer_contexte() {
   CoRevokeClassObject(::Jeton);
   ::pFab->Release();
}
